@echo off



@echo *************************************************************************************************************
@echo 				WELCOME TO RATIONAL PORTFOLIO MANAGER V6.1.2.6 MIGRATION
@echo *************************************************************************************************************

@echo Please enter the database name to be migrated...
Set /P DB=
if "%DB%" == "" (@echo The database name cannot be blank, provide valid database name....
set /P DB=
)

@echo Please enter the username of the instance owner...
Set /P USR=

if "%USR%" == "" (@echo The username of the instance owner cannot be blank, provide valid username....
set /P USR=
)


@echo Please enter the password of the instance owner...
Set /P PWRD=
if "%PWRD%" == "" (@echo The password of the instance owner cannot be blank, provide a valid password...
set /P PWRD=
)

@echo Please enter the username of the connected user if any or leave it blank...
Set /P DBUSER=
if "%DBUSER%" == "" (SET ALIAS="N"
) ELSE SET ALIAS="Y" 

if %ALIAS%=="Y" (@echo Please enter the password for the connected user...
Set /P DBPASS=
if "%DBPASS%" == "" (@echo The password for the connected user cannot be blank, provide valid password....
set /P DBPASS=
))

@echo Please enter the version number of your DB2 UDB you are using(type 7 or 8)
if "%DBVERS%" == "" (@echo Version number for DB2 UDB cannot be blank, provide valid version "type 7 or 8"
set /P DBVERS=
)

set TBSCHEM=%USR%




@echo Restarting DB2 instance....
@echo -----------------------------------------------------------------------------------------------------------------
db2 force applications all
db2stop force
db2start
@echo -----------------------------------------------------------------------------------------------------------------
@echo If no errors encountered during the startup of DB2 instance
pause

db2 connect to %DB% user %USR% using %PWRD%


db2 -x "SELECT 'SET VERSION=' || CAST(ELEMENT_NAME AS CHAR(7)) FROM TMT_SETTINGS WHERE ELEMENT_ID='CLIENT_VERSION_NUMBER'" > version.bat

CALL version.bat

if %VERSION% NEQ 6.1.1.5 (@echo Your database is not at the right level "6.1.1.5".
@echo You need to upgrade your database to RPM 6.1.1.5 level first,then upgrade to RPM 6.1.2.6 level.
 goto :done
)


@echo Starting migration from RPM v6.1.1.5 to RPM v6.1.2.6.....
@echo -----------------------------------------------------------------------------------------------------------------
db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect 

db2 SET CURRENT SCHEMA %TBSCHEM%
if %ERRORLEVEL%  NEQ   0 goto :error_schema 

db2 -tvf migration6126.sql > migration6126.out



cd ..

if %DBVERS% == 7 (cd cspV7) else cd cspV8

@echo Creating Store Procedures.....
@echo -----------------------------------------------------------------------------------------------------------------
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
if %ERRORLEVEL%  NEQ   0 goto :error_connect
) else db2 connect to %DB% user %USR% using %PWRD%

call createsp > createsp.out
@echo -----------------------------------------------------------------------------------------------------------------


@echo Binding the code.....
@echo -----------------------------------------------------------------------------------------------------------------
db2 force applications all
db2stop force
db2start
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
if %ERRORLEVEL%  NEQ   0 goto :error_connect
) else db2 connect to %DB% user %USR% using %PWRD%

call bindall %TBSCHEM% > bindall.out
@echo -----------------------------------------------------------------------------------------------------------------

cd ..
cd migration

@echo Running Statistics......
@echo -----------------------------------------------------------------------------------------------------------------
db2 connect to %DB% user %USR% using %PWRD%
if %ERRORLEVEL%  NEQ   0 goto :error_connect 
call Reorgstats61 %TBSCHEM% > Reorgstats61.out
@echo -----------------------------------------------------------------------------------------------------------------


@echo Checking for successful database migration.....
@echo -----------------------------------------------------------------------------------------------------------------
if %ALIAS%=="Y" (db2 connect to %DB% user %DBUSER% using %DBPASS%
if %ERRORLEVEL%  NEQ   0 goto :error_connect
) else db2 connect to %DB% user %USR% using %PWRD%

db2 SET CURRENT SCHEMA %TBSCHEM%
if %ERRORLEVEL%  NEQ   0 goto :error_schema 

db2 call sp_get_version()

db2 connect reset
@echo -----------------------------------------------------------------------------------------------------------------




goto :done


:error_connect
echo One of the parameters specified to connect to the database is incorrect
@echo off

:error_schema
echo Schema name %TBSCHEM% is undefined Provide the right schema name
@echo off
:done
set DB=
set USR=
set PWRD=
set DBUSER=
set DBPASS=
set TBSCHEM=
set ALIAS=
set DBVERS=