@ECHO off


SET OWNER=
SET OWNERPASS=
SET DIR=logs
SET RESPONSE=
SET LOC=
SET CON=
SET FILENAME=RPMVERSION.bat
SET VALID_COUNT=
SET ORIGINAL_PATH=%PATH%

echo.
echo ******************************************************************
echo *           Welcome to RPM 6.1.2.6 Migration Script              *
echo *                                                                *
echo * This script migrates your connected user to 6.1.2.6.           *
echo *                                                                *
echo ******************************************************************

@echo.

REM asking ORACLE_HOME

if "%ORACLE_HOME%" EQU "" goto ask_ORACLE_HOME_2
echo **********************************************************************
echo  The script has verified that ORACLE_HOME is set to %ORACLE_HOME%
echo **********************************************************************


:ask_ORACLE_HOME

SET RESPONSE=
SET /p RESPONSE=Is this the right value?(y/n)

IF "%RESPONSE%" EQU "Y" GOTO after_ORACLE_HOME
IF "%RESPONSE%" EQU "y" GOTO after_ORACLE_HOME

IF "%RESPONSE%" EQU "n" GOTO ask_ORACLE_HOME_2
IF "%RESPONSE%" EQU "N" GOTO ask_ORACLE_HOME_2

echo Invalid entry!
goto ask_ORACLE_HOME




:ask_ORACLE_HOME_2

SET ORACLE_HOME=
SET /p ORACLE_HOME=Please enter ORACLE_HOME:
IF "%ORACLE_HOME%" NEQ "" GOTO after_ORACLE_HOME
echo Invalid entry!
goto ask_ORACLE_HOME_2

:after_ORACLE_HOME

REM check if sqlplus exists

if not exist %ORACLE_HOME%\bin\sqlplus.exe goto no_sqlplus

REM add oracle_home\bin to path
IF EXIST %FILENAME% DEL %FILENAME%

SET PATH=%PATH%;%ORACLE_HOME%\bin


:ask_loc

SET LOC=
SET /p LOC=Is your RPM database installed on this machine?(y/n)
IF "%LOC%" EQU "Y" SET LOC="y"
IF "%LOC%" EQU "N" SET LOC="n"

IF "%LOC%" EQU "y" GOTO after_loc
IF "%LOC%" EQU "n" GOTO ask_ORACLE_SID_2
echo Invalid entry!
goto ask_loc


:after_loc


REM checking ORACLE_SID

if "%ORACLE_SID%" EQU "" goto ask_ORACLE_SID_2
echo **********************************************************************
echo  The script has verified that ORACLE_SID is set to %ORACLE_SID%
echo **********************************************************************

:ask_ORACLE_SID

SET RESPONSE=
SET /p RESPONSE=Is this the right value?(y/n)

IF "%RESPONSE%" EQU "Y" GOTO after_ORACLE_SID
IF "%RESPONSE%" EQU "y" GOTO after_ORACLE_SID

IF "%RESPONSE%" EQU "n" GOTO ask_ORACLE_SID_2
IF "%RESPONSE%" EQU "N" GOTO ask_ORACLE_SID_2

echo Invalid entry!
goto ask_ORACLE_SID


:ask_ORACLE_SID_2

SET ORACLE_SID=
IF "%LOC%" EQU "n" SET /p ORACLE_SID=Please enter TNS string:
IF "%LOC%" EQU "y" SET /p ORACLE_SID=Please enter ORACLE_SID:
IF "%ORACLE_SID%" NEQ "" GOTO after_ORACLE_SID
echo Invalid entry!
goto ask_ORACLE_SID_2

:after_ORACLE_SID


REM Checking OWNER

:ask_owner

SET OWNER=
SET /p OWNER=Please enter IBMRPM schema owner:
IF "%OWNER%" NEQ "" GOTO after_owner
echo Invalid entry!
goto ask_owner

:after_owner


REM Checking OWNERPASS

:ask_owner_pass

SET OWNERPASS=
SET /p OWNERPASS=Please enter IBMRPM schema owner password:
IF "%OWNERPASS%" NEQ "" GOTO after_owner_pass
echo Invalid entry!
goto ask_owner_pass

:after_owner_pass

REM GET CON USER

:ask_con

SET CONUSER=
SET /p CONUSER=Please enter IBMRPM connected user name:
IF "%CONUSER%" NEQ "" GOTO after_con
echo Invalid entry!
goto ask_con

:after_con


REM GET CON PASS

:ask_con_pass

SET CONPASS=
SET /p CONPASS=Please enter IBMRPM connected user password:
IF "%CONPASS%" NEQ "" GOTO after_con_pass
echo Invalid entry!
goto ask_con_pass

:after_con_pass


REM GET SYS PASS

:ask_sys_pass

SET SYSPASS=
SET /p SYSPASS=Please enter sys password:
IF "%SYSPASS%" NEQ "" GOTO after_sys_pass
echo Invalid entry!
goto ask_sys_pass

:after_sys_pass


REM Checking Loc

SET CON=
if "%LOC%" EQU "y"  SET CON=%OWNER%/%OWNERPASS%
if "%LOC%" EQU "Y"  SET CON=%OWNER%/%OWNERPASS%
if "%LOC%" EQU "n"  SET CON=%OWNER%/%OWNERPASS%@%ORACLE_SID%
if "%LOC%" EQU "N"  SET CON=%OWNER%/%OWNERPASS%@%ORACLE_SID%


if "%LOC%" EQU "y" goto without_sid
if "%LOC%" EQU "Y" goto without_sid
if "%LOC%" EQU "n" goto with_sid
if "%LOC%" EQU "N" goto with_sid

:with_sid
SET SYS_CON_STR=sys/%SYSPASS%@%ORACLE_SID%
SET CON_CON_STR=%CONUSER%/%CONPASS%@%ORACLE_SID%
REM ECHO %SYS_CON_STR%
REM ECHO %CON_CON_STR%
goto after_set_con

:without_sid
SET SYS_CON_STR=sys/%SYSPASS%
SET CON_CON_STR=%CONUSER%/%CONPASS%


:after_set_con

sqlplus -S /nolog @scripts\check\check_con.sql %CON%
IF "%ERRORLEVEL%" NEQ "0" goto err_no_con

sqlplus -S /nolog @scripts\check\check_con_sys.sql %SYS_CON_STR%
IF "%ERRORLEVEL%" NEQ "0" goto no_con_sys

sqlplus -S /nolog @scripts\check\check_con.sql %CON_CON_STR%
IF "%ERRORLEVEL%" NEQ "0" goto no_con_con


IF NOT EXIST logs mkdir logs

IF EXIST %FILENAME% DEL %FILENAME%

echo.
echo ******************************************************************************
echo * Migration script has gathered all the necessary information for migrating  *
echo * your connected user.                                                       *
echo ******************************************************************************
echo.
:ask_sure

SET RESPONSE=
SET /p RESPONSE=Are you sure you want to migrate your connected user now?(y/n)
IF "%RESPONSE%" EQU "Y" GOTO after_sure
IF "%RESPONSE%" EQU "y" GOTO after_sure
IF "%RESPONSE%" EQU "n" GOTO cancel_mig
IF "%RESPONSE%" EQU "N" GOTO cancel_mig
echo Invalid entry!
goto ask_sure

:after_sure

sqlplus -S %CON% @scripts\check\recycle.sql >> %FILENAME%
sqlplus /nolog @utils\createpmosecu.sql %SYS_CON_STR% %CON% %CONUSER%
sqlplus /nolog @utils\createpmosyn.sql %OWNER% %CON_CON_STR%
IF EXIST %FILENAME% DEL %FILENAME%
sqlplus -S %CON% @scripts\check\recycle.sql >> %FILENAME%

echo.
echo *******************************************************************************
echo * Migration logs are created in the logs folder.                              *
echo * End of migration to 6.1.2.6                                                 *
echo * Exiting 6.1.2.6 Migration Script                                            *
echo *******************************************************************************
echo.
IF EXIST %FILENAME% DEL %FILENAME%

goto EXT

:err_no_con
	echo.
	echo ***********************************************************************
	echo * No migration was performed.                                         *
	echo * Reason: RPM schema owner was not able to connect to RPM database.   *
	echo * Exiting IBMRPM 6.1.2.6 Migration Script.                            *
	echo ***********************************************************************
	echo.
	goto EXT
	
:no_con_sys
	echo ***********************************************************************
	echo * No migration was performed.                                         *
	echo * Reason: sys user was not able to connect to RPM database.           *
	echo * Exiting IBMRPM 6.1.2.6 Migration Script.                            *
	echo ***********************************************************************

	goto EXT
:no_con_con
	echo ***********************************************************************
	echo * No migration was performed.                                         *
	echo * Reason: connected user was not able to connect to RPM database.     *
	echo * Exiting IBMRPM 6.1.2.6 Migration Script.                            *
	echo ***********************************************************************

	goto EXT

:cancel_mig
	echo.
	echo **********************************************************************
	echo * No migration was performed.                                        *
	echo * Reason: Migration was cancelled by the user.                       *
	echo * Exiting 6.1.2.6 RPM Migration Script.                              *
	echo **********************************************************************
	echo.
	goto EXT


:no_sqlplus
	echo.
	echo *********************************************************************
	echo * No migration was performed.                                         
	echo * Reason: sqlplus not found in %ORACLE_HOME%\bin directory.               
	echo * Exiting 6.1.2.6 Migration Script.                                   
	echo *********************************************************************
	echo.
	goto EXT


:EXT
SET PATH=%ORIGINAL_PATH%
IF EXIST %FILENAME% DEL %FILENAME%
SET REPLY=
SET DB=
SET USER=
SET PASS=
SET LOC=


